<p>Command injections are other common type of attacks. It is easy to overlook on the backend. In this case, the attacker will try to provide an input to the API to abuse the underlying execution layer and execute arbitrary code. In the worst case, the attacker can gain access to the server by opening a reverse shell, or utilizing similar techniques. From that point, it will have a full control over the system. May can pivot to other machines, dump databases, get credentials, user information, or anything else. Therefore, must take extra care when we have to call out to system commands.</p>
<p>Take the following very basic example. We have an API endpoint that monitors a server by pinging it.</p>
<p><img height="470" width="628" src="/static/ci-1.png" alt="Command Injection 1" style="display: block; margin-left: auto; margin-right: auto;" /></p>
<p></p>
<p>The API above takes a URL, like “http://127.0.0.1:8000/?ip=8.8.8.8”, then executes a single ping on that. When the ping succeeds, the result returned. So far, so good. But the endpoint is vulnerable for command injection. Take a step back and think about what's going on in the background. We receive a user input, trust it, and pass it down to the OS level. For example, if the API receives an input like this the following, it could write a reverse shell to a file and execute it at every boot:</p>
<blockquote>
<p>http://127.0.0.1:8000/?ip=8.8.8.8%3Becho%20%22hi%22%20%3E%20%2Ftmp%2Fhello.txt</p>
</blockquote>
<p>The output of the command above would show the exact same ping, but a /tmp/hello.txt file would have been created as well.</p>
<p>As you may see, the issue and solution is similar to what we had with LFI. We must validate the user input and never trust the user. Even if we know the audience of the API, an attacker may have already taken over control of a trusted account. Let's see how the fixed code would look like.</p>
<p><img height="525" width="630" src="/static/ci-1-solution.png" alt="Command Injection 1 Solution" style="display: block; margin-left: auto; margin-right: auto;" /></p>
<p>What's done? We do check for the IP matches to the expected regex, i.e., we are doing some sort of input validation. Also, we replaced the “os.popen” call with “subprocess.call”. That's not required, but highly recommended, as the parameters escaped properly by “subprocess.call”; the “os.popen” is unsafe.</p>
<p>During reviews, always look out for calling out to subprocess, or waiting input from user that is concatenated in a way or other to a command call. You can get the whole code and try to play around/fix it yourself using the <a href="https://drive.google.com/file/d/1crfi4keM94gQxKyZWC1cPCJ3IQxWdjWz/view?usp=drive_link" target="_blank" rel="noopener">pre-made Django app</a>.</p>